/**
 * Class Name	: BaseException
 * Description	: ⺻ exception  Ŭ
 * Date 				: 2002/09/06
 * Author			: Moon-Ho, Lee (conv2@nvision.gsnu.ac.kr)
 * History			: 2002/09/06 first created.
 */

/*
 * BaseException ҽ  ֽ () ö쾾 帳ϴ.
 */

package com.conv2.imageGS.Exception;

/**
 * ⺻ exception. 
 * 
 * @author conv2@nvision.gsnu.ac.kr
 * @version 1.0.0
 */
public class BaseException extends Exception 
{

	/**
	 * Exception chain root exception
	 */
	public Exception originalException;

	/**
	 * 
	 */
	public BaseException() 
	{
		super();
		originalException = null;
	}

	/**
	 * 
	 *
	 * @param s ޽
	 */
	public BaseException(String s) 
	{
		super(s);
		originalException = null;
	}

	/**
	 * 
	 *
	 * @param s        ޽
	 * @param original  exception
	 */
	public BaseException( String s, Exception original ) 
	{
		super( s );
		originalException = original;
	}

	/**
	 * exception ߻ stack Ѵ.
	 *
	 * @param ps stack tracing  print stream
	 * @see   #printStackTrace( java.io.PrintWriter pw )
	 * @see   #printStackTrace()
	 */
	public void printStackTrace( java.io.PrintStream ps ) 
	{
		if( originalException == null ) 
		{
			super.printStackTrace( ps );
		} 
		else 
		{
			ps.println( this );
			ps.println( "\nRoot cause : \n" );
			originalException.printStackTrace( ps );
		}
	}

	/**
	 * exception ߻ stack Ѵ.
	 *
	 * @param pw stack tracing  print writer
	 * @see   #printStackTrace( java.io.PrintStream ps )
	 * @see   #printStackTrace()
	 */
	public void printStackTrace( java.io.PrintWriter pw ) 
	{
		if( originalException == null ) 
		{
			super.printStackTrace( pw );
		} 
		else 
		{
			pw.println( this );
			pw.println( "\nRoot cause : \n" );
			originalException.printStackTrace( pw );
		}
	}

	/**
	 * exception ߻ stack ǥ   Ѵ.
	 *
	 * @see #printStackTrace( java.io.PrintStream ps )
	 * @see #printStackTrace( java.io.PrintWriter pw )
	 */
	public void printStackTrace() 
	{
		printStackTrace( System.err );
	}
}